from swiginac import *
from SyFi import * 

def sum(u_char,fe): 
    ujs = symbolic_matrix(1,fe.nbf(), u_char) 
    u = 0 
    for j in range(0,fe.nbf()): 
        u += ujs.op(j)*fe.N(j) 
    u = u.evalm()
    return u,ujs 




nsd = cvar.nsd = 3 
polygon = ReferenceTetrahedron()
fe = VectorCrouzeixRaviart(polygon,1)

# create sum u_i N_i
u, ujs = sum("u", fe) 
n = symbol("n") 

for i in range(0,fe.nbf()): 

  # nonlinear power-law diffusion term 
  mu = inner(grad(u), grad(u))
  fi_diffusion = pow(mu,n)*inner(grad(u), grad(fe.N(i))) 
  
  # nonlinear convection term 
  uxgradu = (u.transpose()*grad(u)).evalm()  
  fi_convection = inner(uxgradu, fe.N(i), True) 

  fi = fi_diffusion + fi_convection

  Fi = polygon.integrate(fi) 

  for j in range(0,fe.nbf()): 
    # differentiate to get the Jacobian 
    uj = ujs.op(j) 
    Jij = diff(Fi, uj) 
    print "J[%d,%d]=%s\n"%(i,j, Jij.evalf().printc())






