
from swiginac import *
from SyFi import *

from tools import * 
from code_gen import *

def create_A_string_div(fe1, fe2):
  A_str = "  double A[%d][%d];\n"%(fe1.nbf(), fe2.nbf())
  domain = fe1.getPolygon()
  for i in range(0,fe1.nbf()):
    for j in range(0,fe2.nbf()):
      integrand = inner(div(fe1.N(i)),fe2.N(j))
      Aij = domain.integrate(integrand)
      A_str += "  A[%d][%d]=(%s)*D;\n"%(i,j,Aij.evalf().printc())

  A_str += """

  pair<int,int> index;
  for (int i=0; i< %d; i++) {
    index.first = ii_dof[i];
    for (int j=0; j< %d; j++) {
      index.second = ij_dof[j];
      matrix[index] += A[i][j];
    }
  }
""" % ( fe1.nbf(), fe2.nbf())
  return A_str




nsd = 3; cvar.nsd = 3
order = 1 

t = ReferenceTetrahedron()

fe_sigma = ArnoldFalkWintherWeakSymSigma(t, 1)
fe_u     = ArnoldFalkWintherWeakSymU(t, 1)



G = symbolic_matrix(3,3, "G") 
x0 = symbol("x0"); y0 = symbol("y0"); z0 = symbol("z0")
p0 = matrix(nsd,1,[x0,y0,z0])



filename = "matrix_factory_ux_div_sigma_3D"
cfile = open("%s.cc"%filename,'w')
header = create_header() 
cfile.write(header) 




for order in range(1,2): 

  fe_sigma.set(order)
  fe_sigma.compute_basis_functions()
  fe_u.set(order)
  fe_u.compute_basis_functions()


  i_dof_string   = create_tensor_dof_string(fe_sigma, G, p0, "i") 
#  print "i_dof_string ", i_dof_string	
  j_dof_string   = create_vector_dof_string(fe_u, G, p0, "j", "j") 
#  print "j_dof_string ", j_dof_string	
  dof_string = i_dof_string + j_dof_string
  elmat_string = create_A_string_div(fe_sigma, fe_u)
  funcname = "%s_order%d"%(filename, order)
  cfunc_string = create_function_string_3D_2dofs(funcname, dof_string, elmat_string)  

  print "computing 3D div element matrix for order %d  "% order
  cfile.write("\n\n/* ------------- order %d ---------------*/\n\n"%order)   
  cfile.write(cfunc_string)

tail = create_tail() 
cfile.write(tail) 



