
from swiginac import *
from SyFi import *

from tools import * 
from code_gen import *

def create_A_string_mass(fe):
  A_str = "  double A[%d][%d];\n"%(fe.nbf(), fe.nbf())
  domain = fe.getPolygon()
  for i in range(0,fe.nbf()):
    for j in range(0,fe.nbf()):
      integrand = inner(fe.N(i),fe.N(j))
      Aij = domain.integrate(integrand)
      A_str += "  A[%d][%d]=(%s)*D;\n"%(i,j,Aij.evalf().printc())

  A_str += "  int nbf = %d;" % fe.nbf()
  A_str += """

  pair<int,int> index;
  for (int i=0; i< nbf; i++) {
    index.first = ii_dof[i];
    for (int j=0; j< nbf; j++) {
      index.second = ii_dof[j];
      matrix[index] += A[i][j];
    }
  }
"""
  return A_str




nsd = 3; cvar.nsd = 3
order = 1 

t = ReferenceTetrahedron()

fe_sigma = ArnoldFalkWintherWeakSymSigma(t,order)


G = symbolic_matrix(3,3, "G") 
x0 = symbol("x0"); y0 = symbol("y0"); z0 = symbol("z0")
p0 = matrix(nsd,1,[x0,y0,z0])



filename = "matrix_factory_mass_sigma_3D"
cfile = open("%s.cc"%filename,'w')
header = create_header() 
cfile.write(header) 




for order in range(1,2): 

  fe_sigma.set(order)
  fe_sigma.compute_basis_functions()

  dof_string   = create_tensor_dof_string(fe_sigma, G, p0, "i") 
  elmat_string = create_A_string_mass(fe_sigma)
  funcname = "%s_order%d"%(filename, order)
  cfunc_string = create_function_string_3D(funcname, dof_string, elmat_string)  

  print "computing 3D mass element matrix for order %d  "% order
  cfile.write("\n\n/* ------------- order %d ---------------*/\n\n"%order)   
  cfile.write(cfunc_string)

tail = create_tail() 
cfile.write(tail) 



