#!/usr/bin/env python


from Functions import *
from MatrixFactory_MxElasticity import  *
from MatSparse import *
from Mesh import *
from Numeric import *
from ConjGrad import *
from math import *
from Misc import *
from plotter import *
import unittest
import os
from pycc import common
from RandomArray import *



mesh = Mesh(os.path.join(common.DataDir, "box", "box3D.xml.gz"))
matrix_factory = MatrixFactory(mesh)
M =  matrix_factory.computeSigmaMassMatrix()

printDofs(matrix_factory.idof)

M.dumpToOctave("M", "Ms.m")

u = random(M.n)
b = zeros(M.n,  typecode='d')
u = conjgrad(M, u, b, 10E-6, True)

Mps =  matrix_factory.computePxSigmaMassMatrix()
printDofs(matrix_factory.jdof)
Mps.dumpToOctave("Mp", "Mps.m")

B =  matrix_factory.computeUxDivSigmaMatrix()
printDofs(matrix_factory.jdof)
B.dumpToOctave("B", "Bs.m")

print type(matrix_factory.idof)
print type(matrix_factory.jdof)







