#include <Matrix1D.h>
#include <ElementComputations.h>
#include <Dof_double.h>
#include <iostream>
#include <fstream>
#include <utility>
#include <map>
#include <vector>
#include <iterator>




using namespace std;

MapMatrixFactory:: MapMatrixFactory(vector<double>* mesh_) {
    mesh = mesh_;
    matrix = new map<pair<int,int>,double>();
    dof = new Dof_double(true,true); 
    order = 1; 
}

void MapMatrixFactory::computeMassMatrix(bool append_to_matrix) {
    double x0, x1; 
    int element; 
    for (int i=0; i < mesh->size()-1; i++) { 

        x0 = (*mesh)[i]; 
        x1 = (*mesh)[i+1]; 

        element = i; 

	    switch(order) {
	      case 1 :  mass_matrix_1D_1(*matrix,*dof,x0,x1,element); break; 
	      case 2 :  mass_matrix_1D_2(*matrix,*dof,x0,x1,element); break; 
	      case 3 :  mass_matrix_1D_3(*matrix,*dof,x0,x1,element); break; 
	      case 4 :  mass_matrix_1D_4(*matrix,*dof,x0,x1,element); break; 
	      case 5 :  mass_matrix_1D_5(*matrix,*dof,x0,x1,element); break; 
	    }

    }
    
}

void dump_to_matlab(std::map<pair<int,int>,double>& A, const char *varname, const char *s)
{
  ofstream outfile(s, ios::out);
  outfile << "%The matrix\n"; 
  std::map<std::pair<int,int>,double>::const_iterator Ait;
  double eps = 1.0e-10; 

  for(Ait=A.begin(); Ait!=A.end(); Ait++){
    outfile << varname << "(" << (*Ait).first.first+1  << ","
            << (*Ait).first.second+1  << ")=" << (*Ait).second << ";\n"; 
  }
}


