#!/bin/env python 


import os
from distutils.core import setup, Extension
name = 'SyFi' 
swig_cmd ='swig -python -c++ -I../syfi SyFi.i'
os.system(swig_cmd)
package_dir = {}    
sources = ['SyFi_wrap.cxx'] 


trove_classifiers = [
'License :: OSI Approved :: GNU General Public License (GPL)', 
'Programming Language :: C++',
'Programming Language :: Python', 
'Topic :: Scientific/Engineering :: Mathematics' ]
setup(name = 'SyFi', 
      version = '0.4.0', 
      description = 'Symbolic Finite Elements',  
      author = 'Kent-Andre Mardal', 
      author_email = 'kent-and@simula.no',
      url = 'http://www.fenics.org/syfi', 
      classifiers = trove_classifiers, 
      py_modules=['SyFi'],
      packages=['ufccodegen'],
      ext_modules = [Extension('_' + 'SyFi', sources, 
                     include_dirs=['.', '../syfi'],   
		     libraries=['syfi'], 
		     library_dirs=['../syfi/.libs'])]) 
	
