import os, sys

# Variables:

include_from    = "local"



# Utility functions:

dof_tools_headers = ["Ptv.h", "Dof_Ptv.h"]
dof_tools_files   = ["Ptv.h", "Dof_Ptv.h", "Ptv.cpp", "DofT.h"]

def use_local_includes():
    return include_from.lower() == 'local'

def get_namespace():
    # select which namespace to wrap the generated code in
    if include_from.lower() == "pycc":
        return "pycc"
    return "SyFi"

def get_system_includes():
    if include_from.lower() == 'local':
        return []
    elif include_from.lower() == 'syfi':
        dof_tools_dir = "SyFi"
    elif include_from.lower() == 'pycc':
        dof_tools_dir = "pycc/Functions" # this might be moved later
    else:
        raise "Unknown include_from option " + include_from + ", choose 'local', 'syfi' or 'pycc'"
    return [ os.path.join(dof_tools_dir, f) for f in dof_tools_headers ]

def get_local_includes():
    if include_from.lower() == 'local':
        dof_tools_dir = ""
    elif include_from.lower() == 'syfi':
        return []
    elif include_from.lower() == 'pycc':
        return []
    else:
        raise "Unknown include_from option " + include_from + ", choose 'local', 'syfi' or 'pycc'"
    return [ dof_tools_dir + f for f in dof_tools_headers ]

def get_script_path():
    return os.path.abspath(os.path.dirname(__file__))

def get_tool_files():
    d = get_script_path()
    return [ os.path.join(d, "dof_tools", f) for f in dof_tools_files ]

def get_tool_libs():
    if include_from.lower() == 'local':
        return []
    elif include_from.lower() == 'syfi':
        return ["syfi"]
    elif include_from.lower() == 'pycc':
        return ["Functions"]
    raise "Unknown include_from option " + include_from + ", choose 'local', 'syfi' or 'pycc'"

def get_tool_pkgs():
    if include_from.lower() == 'local':
        return []
    elif include_from.lower() == 'syfi':
        return ["syfi"]
    elif include_from.lower() == 'pycc':
        return ["pycc-0"]
    raise "Unknown include_from option " + include_from + ", choose 'local', 'syfi' or 'pycc'"

