#ifndef DOF_IS_INCLUDED
#define DOF_IS_INCLUDED

#include "FE.h" 

namespace SyFi {


class Dof {
    protected: 
        int counter; 
        // the structures loc2dof, dof2index, and doc2loc  are completely dynamic
        // they are all initialized and updated by insert_dof(int e, int i, ex Li) 

        // (int e, int i) -> ex Li 
        std::map<std::pair<int,int>, GiNaC::ex>          loc2dof;   
        // (ex Lj)    -> int j 
        std::map<GiNaC::ex,int,GiNaC::ex_is_less>          dof2index; 
        // (int j)        -> ex Lj 
        std::map<int,GiNaC::ex>                     index2dof;  
        // (ex j)    -> vector< pair<e1, i1>, ..  pair<en, in> >
        std::map <GiNaC::ex, std::vector<std::pair<int,int> >,GiNaC::ex_is_less >  dof2loc;     

    public: 
        Dof() { counter = 0; }
        ~Dof() {}
        int insert_dof(int e, int i, GiNaC::ex Li);  // to update the internal structures  

        // Helper functions to be used when the dofs have been set   
        // These do not modify the internal structure 
        int glob_dof(int e, int i); 
        int glob_dof(GiNaC::ex Lj); 
        GiNaC::ex  glob_dof(int j); 
        int size();  
	std::vector<std::pair<int, int> > glob2loc(int j); 
        void clear(); 
}; 

}

#endif 

