#include "ExpressionCollection.h"

using namespace GiNaC;
using namespace std;

namespace SyFi
{

ExpressionCollection::ExpressionCollection(TempSymbolHandler & tsh_):
    tsh(tsh_)
{
}

// insert an expression in the datastructures with no comparison to existing expressions
void ExpressionCollection::insert_expression(symbol s, const ex & e)
{
    exToSym.insert(      pair<ex,symbol>(e, s) );
    symToEx.insert(      pair<symbol,ex>(s, e) );
    symExList.push_back( pair<symbol,ex>(s, e) );
}

// register an expression in our datastructures and get back a symbol representing it
symbol ExpressionCollection::register_expression(const ex & ein)
{
    ex e = ein.evalf();
    exhashmap<symbol>::iterator i = exToSym.find(e);
    symbol s;
    if( i != exToSym.end() )
    {
        s = i->second;
    }
    else
    {
        s = tsh.get_next_symbol();
        insert_expression(s, e);
    }
    return s;
}

} // namespace SyFi
