#ifndef EXPRESSIONCOLLECTION_IS_INCLUDED
#define EXPRESSIONCOLLECTION_IS_INCLUDED

#include <list>
#include <ginac/ginac.h>
#include "TempSymbolHandler.h"

namespace SyFi
{

typedef std::pair<GiNaC::symbol,GiNaC::ex> symexpair;

class ExpressionCollection
{
    GiNaC::exhashmap<GiNaC::symbol> exToSym;
    GiNaC::exmap                    symToEx;
    std::list<symexpair>            symExList;

    TempSymbolHandler & tsh;
public:
    ExpressionCollection(TempSymbolHandler & tsh_);

    /* 
     * Insert an expression in the datastructures with
     * no comparison to existing expressions.
     */
    void insert_expression(GiNaC::symbol s, const GiNaC::ex & e);

    /* 
     * Register an expression in the datastructures and get back a symbol 
     * representing it, possibly refering to an existing expression.
     */ 
    GiNaC::symbol register_expression(const GiNaC::ex & e);

    GiNaC::exhashmap<GiNaC::symbol> & get_ex_to_sym()  { return exToSym; }
    GiNaC::exmap                    & get_sym_to_ex()  { return symToEx; }
    std::list<symexpair>            & get_symex_list() { return symExList; }
};

} // namespace syfi
#endif

