#ifndef __ExpressionSimplifier_h__
#define __ExpressionSimplifier_h__


#include <string>
#include <list>
//#include <pair>
#include <ginac/ginac.h>

#include "TempSymbolHandler.h"
#include "ExpressionCollection.h"

namespace SyFi
{

class ExpressionSimplifier
{
private:
    TempSymbolHandler tsh;
    std::list< std::pair<GiNaC::symbol,GiNaC::ex> > input;

    ExpressionCollection output;

public:

    ExpressionSimplifier(const std::string & tempsymbolbasename="_s", int initialsymbolnumber=0);
    
    void add(const GiNaC::symbol & s, GiNaC::ex e);
    void add(const std::list<std::pair<GiNaC::symbol,GiNaC::ex> > & selist);

    void simplify();
    void simplify_old();
    
    ExpressionCollection & get_output() { return output; }
};


} // namespace SyFi

#endif 
