#ifndef LAGRANGEFE_IS_INCLUDED
#define LAGRANGEFE_IS_INCLUDED 

#include "FE.h"

namespace SyFi {

class LagrangeFE : public StandardFE {
    public: 
        LagrangeFE(); 
        LagrangeFE(Polygon& p, int order = 1);  
        virtual ~LagrangeFE() {}

        virtual void compute_basis_functions();  
}; 



class VectorLagrangeFE : public StandardFE {
    protected: 
        int size; 
    public: 
        VectorLagrangeFE();
        VectorLagrangeFE(Polygon& p, int order = 1, int size = -1); 
        ~VectorLagrangeFE() {}

        virtual void set_size(int size_);  
        virtual void compute_basis_functions();  
}; 



class TensorLagrangeFE : public StandardFE {
    protected: 
        int size; 
    public: 
        TensorLagrangeFE();
        TensorLagrangeFE(Polygon& p, int order = 1, int size = -1); 
        ~TensorLagrangeFE() {}

        virtual void set_size(int size_);  
        virtual void compute_basis_functions();  
}; 


} // namespace SyFi 

#endif
