#ifndef MIXED_FE_IS_INCLUDED
#define MIXED_FE_IS_INCLUDED

#include "FE.h"
#include <vector>
#include <string>

namespace SyFi {


// FIXME: what about memory management ??? 
//
// FIXME: one assumption when using this MixedFE is that non of the dofs 
// in the vector of finite elements have different dofs. This assumption
// is valid for all elements I know of.  
// If this is not appropriate, we could add an int to the dof, in a
// similar way that it is done with the vector elements. 
// The current implementation is more efficient. 
// Could do a consistency check.  

class MixedFE : public FE {
  std::string description; 
   public: 
	std::vector<StandardFE*> mfe; 
   public: 
	MixedFE();
	MixedFE(StandardFE* fe1, StandardFE* fe2);
	virtual ~MixedFE();

  //FIXME: check that the domain are ok. 
  virtual void set_polygon(Polygon& p) {}    // Set polygonal domain 
  virtual Polygon& get_polygon() { return (*(mfe[0])).get_polygon(); }    // Get polygonal domain 
	
  StandardFE* get(int i); 
	void append(StandardFE* fe); 
	
  virtual GiNaC::ex N(int i);      // The i'th basis function
	virtual GiNaC::ex dof(int i);    // The i'th degree of freedom 
	virtual int nbf() const;         // Number of basis functions/degrees of freedom  
  virtual std::string str(); 


}; 

} // namespace SyFi 

#endif 
