#ifndef TIMEELEMENT_IS_INCLUDED
#define TIMEELEMENT_IS_INCLUDED 

#include "FE.h"

namespace SyFi {

  class SpaceTimeDomain : public Polygon {
    Line* time_line; 
    Polygon* polygon; 
    public: 
    SpaceTimeDomain(Line* time_line_, Polygon* polygon_); 

    virtual int no_space_dim() const; 

    virtual Line line(int i) const; 

    virtual GiNaC::ex repr(Repr_format = SUBS_PERFORMED); 
    virtual std::string str(); 

    virtual GiNaC::ex integrate(GiNaC::ex f, Repr_format format = SUBS_PERFORMED); 
  }; 




  class SpaceTimeElement : public StandardFE {
    int order; 
    Line* time_line; 
    StandardFE* fe; 

    public: 
    SpaceTimeElement(); 
    SpaceTimeElement(Line* time_line_, int order_, StandardFE* fe_); 
    virtual ~SpaceTimeElement() {} 

    void set_time_domain(Line* line); 
    void set_order_in_time(int order); 
    void set_spatial_element(StandardFE* fe); 
    virtual void compute_basis_functions(); 
  };

} // namespace SyFi 


#endif 


