#ifndef SYFI_IS_INCLUDED
#define SYFI_IS_INCLUDED

// misc
#include "syfi_version.h"
#include "tools.h"

// dof mapping
#include "Dof.h"
#include "DofT.h"

// base classes for element hierarchy
#include "Polygon.h"
#include "FE.h"
#include "MixedFE.h"

// concrete element implementations
#include "LagrangeFE.h"
#include "CrouzeixRaviart.h"
#include "P0.h"
#include "RaviartThomas.h"
#include "DiscontinuousLagrangeFE.h"
#include "HermiteFE.h"
#include "Nedelec.h"
#include "Nedelec2Hdiv.h"
#include "Bubble.h"
#include "ArnoldFalkWintherWeakSym.h"
#include "Robust.h"
#include "SpaceTimeElement.h"

// example code
#include "ElementComputations.h"

// code generation related
#include "TempSymbolHandler.h"
#include "ExpressionCollection.h"  
#include "ExpressionSimplifier.h"  

#endif 

