#include "symbol_factory.h"
#include "utilities.h"

#include <stdexcept>
#include <sstream>
#include <map>
using namespace std;
using namespace GiNaC;


namespace SyFi {

// TODO: make structure for these
//namespace space
//{
	int nsd = 2;
	//GiNaC::symbol p[4];
	GiNaC::symbol x("SYFI NOT INITIALIZED");
	GiNaC::symbol y("SYFI NOT INITIALIZED");
	GiNaC::symbol z("SYFI NOT INITIALIZED");
	GiNaC::symbol t("SYFI NOT INITIALIZED");
//}


GiNaC::symbol infinity("SYFI NOT INITIALIZED");
GiNaC::symbol DUMMY("SYFI NOT INITIALIZED");


// Initialize global variables of SyFi
void initSyFi(int nsd_)
{
	SyFi::nsd      = nsd_;
	SyFi::x        = get_symbol("x");
	SyFi::y        = get_symbol("y");
	SyFi::z        = get_symbol("z");
	SyFi::t        = get_symbol("t");
//SyFi::p[0]     = SyFi::x;
//SyFi::p[1]     = SyFi::y;
//SyFi::p[2]     = SyFi::z;
//SyFi::p[3]     = SyFi::t;
	SyFi::infinity = get_symbol("infinity");
	SyFi::DUMMY    = get_symbol("DUMMY");
}


// =========== symbol factory implementation from ginac manual page 14-15

map<string, symbol> symbol_collection;


bool symbol_exists(const string & name)
{
    return symbol_collection.find(name) != symbol_collection.end();
}


const symbol & get_symbol(const string & name)
{
    map<string, symbol>::iterator i = symbol_collection.find(name);
    if( i != symbol_collection.end() )
    {
        return i->second;
    }
    return symbol_collection.insert(make_pair(name, symbol(name))).first->second;
}


const symbol & isymb(const string & a, int b)
{
    return get_symbol(istr(a,b));
}


GiNaC::ex get_symbolic_vector(int m, const std::string & basename)
{
    cout << "get_symbolic_vector" << endl;
    GiNaC::matrix A(m,1);
    for(int i=0; i<m; i++)
    {
        A.set(i, 0, isymb(basename, i));
    }
    GiNaC::ex e = A;
    return e;
}


GiNaC::ex get_symbolic_matrix(int m, int n, const std::string & basename)
{
    cout << "get_symbolic_matrix" << endl;
    if(m > 9 || n > 9)
    {
        throw std::logic_error("get_symbolic_matrix is not implemented to handle sizes > 9, since the names are simply Aij. Fix in ginac_tools.cpp.");
    }
    GiNaC::matrix A(m,n);
    for(int i=0; i<m; i++)
    {
        for(int j=0; j<n; j++)
        {
            A.set(i, j, isymb(basename, i*10+j));
        }
    }
    GiNaC::ex e = A;
    return e;
}





} //namespace SyFi
