#include "utilities.h"
#include "syfi_version.h"

#include <sstream>
#include <math.h>

//using GiNaC::symbol;
//using std::string;
//using std::map;
using namespace std;



namespace SyFi {


	/* Version information buried into the library */
const int version_major = SYFILIB_MAJOR_VERSION;
const int version_minor = SYFILIB_MINOR_VERSION;
const int version_micro = SYFILIB_MICRO_VERSION;



int dirac(int i, int j) {
    if (i==j) return 1;
    else return 0;
}


string int2string(int i)
{
    ostringstream os;
    os << i;
    return os.str();
}


string istr(const string & a, int b) {
    ostringstream s;
    s << a << b;
    return s.str();
}


string istr(const string & a, int b, int c) {
    ostringstream s;
    s << a << b << "_" <<c;
    return s.str();
}



void print(GiNaC::lst& l) {
    //  for (GiNaC::lst::const_iterator i = l.begin(); i != l.end(); ++i)
    //    cout << *i << endl;
    //
    GiNaC::lst::const_iterator i = l.begin();
    cout <<"GiNaC::lst("<<*i;
    ++i;

    for (; i != l.end() ; ++i) {
        cout << ","<< *i;
    }
    cout <<");"<<endl;
}


void print(GiNaC::exvector& v) {
    cout <<"v=[";
    for (int i=0; i< v.size()-1; i++) {
        cout <<v[i]<<"," <<endl;
    }
    cout <<v[v.size()-1]<< "]"<<endl;
}


void print(std::map<std::pair<int,int>, GiNaC::ex>& A) {
    map<std::pair<int,int>,GiNaC::ex>::iterator iter;
    for (iter = A.begin(); iter != A.end() ; iter++) {
        cout <<"A["<<(*iter).first.first<<","<<(*iter).first.second<<"]="<<(*iter).second<<endl;
    }
}


void print(ex_int_map map) {
    GiNaC::ex b;
    int c;
    ex_int_it iter;
    iter = map.begin();
    cout <<"{" <<b<<":"<<c;
    for (iter = map.begin(); iter != map.end(); iter++) {
        b = (*iter).first; c = map[b];
        cout <<", "<<b<<":"<<c;
    }
    cout <<"}"<<endl;
}


void print(ex_ex_map map) {
    GiNaC::ex b;
    GiNaC::ex c;
    ex_ex_it iter;
    cout <<"{" <<b<<":"<<c;
    for (iter = map.begin(); iter != map.end(); iter++) {
        b = (*iter).first; c = map[b];
        cout <<", "<<b<<":"<<c;
    }
    cout <<"}"<<endl;
}





}







