#ifndef UTILITIES_IS_INCLUDED
#define UTILITIES_IS_INCLUDED

#include <map>

#include <ginac/ginac.h>


namespace SyFi {


// dirac delta function
int dirac(int i, int j);

std::string int2string(int i);

std::string istr(const std::string & a, int b);

std::string istr(const std::string & a, int b, int c);



/* Pair of a symbol and an expression */
typedef std::pair<GiNaC::symbol, GiNaC::ex> symexpair;


/* Dictionary with ex as keys and values */
typedef std::map<GiNaC::ex,GiNaC::ex, GiNaC::ex_is_less>  ex_ex_map;
typedef std::map<GiNaC::ex,int, GiNaC::ex_is_less>  ex_int_map;

/* Iterator associated with the ex-ex dictionary */
typedef std::map<GiNaC::ex,GiNaC::ex>::iterator ex_ex_it;
typedef std::map<GiNaC::ex,int>::iterator ex_int_it;


/* Vector of ex */
//typedef std::vector<GiNaC::ex> ex_vector;

/* Vector of vectors of ex */
//typedef std::vector<GiNaC::exvector> ex_vector_vector;


// print functions
#ifndef SWIG
void print(GiNaC::exvector& v);
void print(GiNaC::lst& l);
void print(ex_ex_map m);
void print(ex_int_map m);
void print(std::map<std::pair<int,int>, GiNaC::ex>& A);
#endif


} // namespace SyFi

#endif
